Package org.optaplanner.core.impl.score.stream.drools.tri

## Class DroolsJoinTriConstraintStream<Solution_,​A,​B,​C>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream<Solution_>
  - - org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream<Solution_>
    - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>
      - - org.optaplanner.core.impl.score.stream.drools.tri.DroolsJoinTriConstraintStream<Solution_,​A,​B,​C>

- All Implemented Interfaces:
    `ConstraintStream`, `TriConstraintStream<A,​B,​C>`, `InnerTriConstraintStream<A,​B,​C>`

      public final class DroolsJoinTriConstraintStream<Solution_,​A,​B,​C>
      extends DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `parent`

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `constraintFactory`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DroolsJoinTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory, DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent, DroolsAbstractUniConstraintStream<Solution_,​C> otherStream, TriJoiner<A,​B,​C> triJoiner)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `DroolsTriCondition<A,​B,​C,​?>` | `getCondition()` |
    `DroolsAbstractBiConstraintStream<Solution_,​A,​B>` | `getLeftParentStream()` |
    `DroolsAbstractUniConstraintStream<Solution_,​C>` | `getRightParentStream()` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.tri.DroolsAbstractTriConstraintStream

      `filter, getCardinality, getFromStreamList, groupBy, groupBy, groupBy, groupBy, groupBy, groupBy, ifExists, ifNotExists, impactScore, impactScore, impactScoreBigDecimal, impactScoreConfigurable, impactScoreConfigurable, impactScoreConfigurableBigDecimal, impactScoreConfigurableLong, impactScoreLong, join`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.drools.common.DroolsAbstractConstraintStream

      `addChildStream, buildConstraint, buildConstraintConfigurable, createRuleItemBuilders, getChildStreams, getConstraintFactory, getExpectedJustificationTypes`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.common.AbstractConstraintStream

      `buildConstraintWeightExtractor, buildConstraintWeightExtractor, impact, penalize, penalizeConfigurable, reward, rewardConfigurable`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintStream

      `getConstraintFactory, impact, impact, penalize, penalize, penalizeConfigurable, penalizeConfigurable, reward, reward, rewardConfigurable, rewardConfigurable`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.tri.InnerTriConstraintStream

      `impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.tri.TriConstraintStream

      `ifExists, ifExists, ifExists, ifExists, ifNotExists, ifNotExists, ifNotExists, ifNotExists, impact, impactBigDecimal, impactConfigurable, impactConfigurableBigDecimal, impactConfigurableLong, impactLong, join, join, join, join, join, join, join, penalize, penalizeBigDecimal, penalizeConfigurable, penalizeConfigurableBigDecimal, penalizeConfigurableLong, penalizeLong, reward, rewardBigDecimal, rewardConfigurable, rewardConfigurableBigDecimal, rewardConfigurableLong, rewardLong`

- - ### Constructor Detail

    - #### DroolsJoinTriConstraintStream

          public DroolsJoinTriConstraintStream​(DroolsConstraintFactory<Solution_> constraintFactory,
                                               DroolsAbstractBiConstraintStream<Solution_,​A,​B> parent,
                                               DroolsAbstractUniConstraintStream<Solution_,​C> otherStream,
                                               TriJoiner<A,​B,​C> triJoiner)

  - ### Method Detail

    - #### getCondition

          public DroolsTriCondition<A,​B,​C,​?> getCondition()

      Specified by:
        `getCondition` in class `DroolsAbstractTriConstraintStream<Solution_,​A,​B,​C>`

    - #### getLeftParentStream

          public DroolsAbstractBiConstraintStream<Solution_,​A,​B> getLeftParentStream()

    - #### getRightParentStream

          public DroolsAbstractUniConstraintStream<Solution_,​C> getRightParentStream()

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`